/**
 * @packageDocumentation
 * @module utils
 */
/**
 * ```hs
 * delay :: number -> Promise ()
 * ```
 *
 * Creates a promise that resolves after n milliseconds. Defaults to 1s.
 *
 * @param ms Milliseconds to delay the promise by. Defaults to 1s.
 * @returns A promise
 */
export declare const delay: (milliseconds?: number) => Promise<unknown>;
export declare type Deferred<T = any> = Promise<T> & {
    id: string;
    resolve: () => void;
};
export declare const defer: <T = any>(value: T, id: string) => Deferred<T>;
export default delay;
